#!/usr/bin/env

__author__ = 'rohe0002'

import base64

from saml2.client import Saml2Client
from saml2 import samlp
from saml2 import saml, config
from saml2.server import Server

def only_allowed_attributes(client, assertion, allowed):
    _aconvs = client.config.attribute_converters

    for statement in assertion.attribute_statement:
        res = []
        for attribute in statement.attribute:
            if attribute.friendly_name:
                fname = attribute.friendly_name
            else:
                fname = ""
                for acv in _aconvs:
                    if acv.name_form == attribute.name_form:
                        fname =  acv._fro[attribute.name]

            if fname in allowed:
                res.append(attribute)
        statement.attribute = res
        
    return assertion

server = Server("idp_conf")

conf = config.SPConfig()
conf.load_file("server_conf")
client = Saml2Client(conf)

ava = { "givenName": ["Derek"], "surname": ["Jeter"],
        "mail": ["derek@nyy.mlb.com"]}

resp_str = "\n".join(server.authn_response(
            identity=ava,
            in_response_to="id1",
            destination="http://lingon.catalogix.se:8087/",
            sp_entity_id="urn:mace:example.com:saml:roland:sp",
            name_id_policy=samlp.NameIDPolicy(
                format=saml.NAMEID_FORMAT_PERSISTENT),
            userid="foba0001@example.com"))

resp_str = base64.encodestring(resp_str)

authn_response = client.response({"SAMLResponse":resp_str},
                                    {"id1":"http://foo.example.com/service"})

for assertion in authn_response.response.assertion:
    ass = only_allowed_attributes(client, assertion, ["surname", "mail"])
    print ass