#!/usr/bin/env python
# -*- coding: utf-8 -*-

from saml2 import config

from saml2.server import Server
from saml2.sigver import security_context

XML_RESPONSE_FILE = "saml_signed.xml"
XML_RESPONSE_FILE2 = "saml2_response.xml"


def _eq(l1,l2):
    return set(l1) == set(l2)

server = Server("idp_conf")
name_id = server.ident.transient_nameid(
    "urn:mace:example.com:saml:roland:sp",
    "id12")


_sign_resp_ = server.do_response(
    "id12",                       # in_response_to
    "http://lingon.catalogix.se:8087/",   # consumer_url
    "urn:mace:example.com:saml:roland:sp", # sp_entity_id
        {"eduPersonEntitlement":"Jeter"},
    name_id = name_id,
    sign=True
)

conf = config.SPConfig()
conf.load_file("sp_2_conf")

sc = security_context(conf)
# should fail
result = sc.correctly_signed_response("%s" % _sign_resp_)
print result