from saml2.sigver import get_xmlsec_binary

__author__ = 'rohe0002'

from saml2 import saml, sigver, samlp, class_name
from saml2.s_utils import factory, do_attribute_statement

PUB_KEY = "test.pem"
PRIV_KEY = "test.key"

xmlexec = "/opt/local/bin/xmlsec1"
sec = sigver.SecurityContext(xmlexec, key_file=PRIV_KEY, cert_file=PUB_KEY, 
                             debug=1)

assertion2 = factory( saml.Assertion,
    version= "2.0",
    id= "11122",
    issue_instant= "2009-10-30T13:20:28Z",
    signature= sigver.pre_signature_part("11122", sec.my_cert),
    attribute_statement=do_attribute_statement({
            ("","","surName"): ("Fox",""),
            ("","","givenName") :("Bear",""),
        })
    )
response = factory(samlp.Response,
        assertion=assertion2,
        id="22233",
        signature=sigver.pre_signature_part("22233", sec.my_cert))


to_sign = [(class_name(assertion2), assertion2.id),
            (class_name(response), response.id)]

s_response = sigver.signed_instance_factory(response, sec, to_sign)

assert s_response is not None
sass = s_response.assertion[0]
assert sass.version == "2.0"
assert sass.id == "11122"

item = sec.check_signature(s_response, node_name=class_name(s_response))

assert isinstance(item, samlp.Response)
