#!/usr/bin/env python

import base64

from saml2 import samlp
from saml2 import saml
from saml2 import config

from saml2.client import Saml2Client
from saml2.server import Server

server = Server("idp_conf")

conf = config.SPConfig()
conf.load_file("server_conf")
client = Saml2Client(conf)

IDP = "urn:mace:example.com:saml:roland:idp"

ava = { "givenName": ["Derek"], "surname": ["Jeter"],
        "mail": ["derek@nyy.mlb.com"]}

resp_str = "\n".join(server.authn_response(
            identity=ava,
            in_response_to="id1",
            destination="http://lingon.catalogix.se:8087/",
            sp_entity_id="urn:mace:example.com:saml:roland:sp",
            name_id_policy=samlp.NameIDPolicy(
                format=saml.NAMEID_FORMAT_PERSISTENT),
            userid="foba0001@example.com"))

resp_str = base64.encodestring(resp_str)

client.allow_unsolicited = True
authn_response = client.response({"SAMLResponse":resp_str}, ())

assert authn_response is not None
  