#!/usr/bin/env python
__author__ = 'rohe0002'

from saml2.metadata import MetaData
from saml2.sigver import SecurityContext

from saml2.server import Server

server = Server("idp_conf")
name_id = server.ident.transient_nameid(
    "urn:mace:example.com:saml:roland:sp",
    "id12")

_sign_resp_ = server.do_response(
    "id12",                       # in_response_to
    "http://lingon.catalogix.se:8087/",   # consumer_url
    "urn:mace:example.com:saml:roland:sp", # sp_entity_id
        {"eduPersonEntitlement":"Jeter"},
    name_id = name_id,
    sign=True
)

md = MetaData()
md.import_metadata(open("idp.xml").read(), "")

sc = SecurityContext("/opt/local/bin/xmlsec1", metadata=md)

result = sc.correctly_signed_response("%s" % _sign_resp_)

print result